/*-
 * Copyright (c) 1998 Kazutaka YOKOTA <yokota@zodiac.mech.utsunomiya-u.ac.jp>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer as
 *    the first lines of this file unmodified.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: $
 */

#ifndef _DEV_MOUSE_VMOUSEREG_H_
#define _DEV_MOUSE_VMOUSEREG_H_

/* mouse */
typedef struct vmouse {
	/* the following fields are managed by vmouse */
	int		ms_index;	/* virtual mouse index# */
	int		ms_minor;	/* minor number of the sub-device */
	int		ms_flags;	/* internal flags */

	/*
	 * Device configuration flags:
	 * The upper 16 bits are common between various mouse drivers.
	 * The lower 16 bits are device-specific.
	 */
	int		ms_config;	

	/* the following fields are set up by the driver */
	char		*ms_name;	/* driver name */
	int		ms_unit;	/* unit # */
	int		ms_type;	/* MOUSE_MODEL_XXX in machine/mouse.h */
	void		*ms_data;	/* the driver's private data */
} vmouse_t;

void			mou_init_struct(vmouse_t *mou, char *name, int type,
					int unit, int config);

/* virtual mouse cdev driver functions */

int			mou_attach(dev_t dev, vmouse_t *mou, struct cdevsw *sw);
int			mou_detach(dev_t dev, vmouse_t *mou, struct cdevsw *sw);

#endif /* !_DEV_MOUSE_VMOUSEREG_H_ */
